<?php
if($_SERVER['REQUEST_METHOD'] === 'POST') {
    $tags = explode("\n", $_POST['tags']);
    $tags = array_map('trim', $tags);
    $tags = array_filter($tags, function($tag) {
        return !empty($tag);
    });

    if(empty($tags)){
        header("Location: /?err=notags");
        exit;
    }


    $jobId=microtime(1).'_'.uniqid();
    #file_put_contents()
    $queueDir=__DIR__.'/../queue';
    $queueDir=realpath($queueDir);
    $queueFile=$queueDir.'/'.$jobId.'.json';
    file_put_contents($queueFile, json_encode($tags));
    header('Location: /?jobid='.$jobId);
    exit;
}

if(isset($_GET['jobid'])){
    $jobId=$_GET['jobid'];
    $queueDir=__DIR__.'/../queue';
    $queueDir=realpath($queueDir);
    $queueFile=$queueDir.'/'.$jobId.'.json';


    $allJobs=glob($queueDir.'/*.json');
    sort($allJobs);
    $myPositionInQueue=array_search($queueFile, $allJobs);



    if(false === $myPositionInQueue) {


        if(isset($_GET['download']) && $_GET['download'] == '1'){
            $dlDir=__DIR__.'/../html/dl';
            $dlDir=realpath($dlDir);
            $zipFile=$dlDir.'/'.$jobId.'.zip';
                header('Content-Type: application/zip');
                header('Content-Disposition: attachment; filename="'.basename($zipFile).'"');
                readfile($zipFile);


            exit;
        }else{
                echo <<<EOT
<html>
<head>
    <title>c3RE AuerBoxTag Generator (Download starting)</title>
    <meta http-equiv="refresh" content="1; url='/?jobid=$jobId&download=1'"> 
</head>
<body>
<img src="/logo.png" alt="c3RE Logo" style="height: 200px "/>
Your job $jobId is Finished.

<a href="/">Back</a>
</body>
</html>
EOT;



        }
        header('HTTP/1.1 404 Not Found');
        exit;
    }

    $myPositionInQueue++;

    echo <<<EOT
<html>
<head>
    <title>c3RE AuerBoxTag Generator ($myPositionInQueue)</title>
    <meta http-equiv="refresh" content="1">
</head>
<body>
<img src="/logo.png" alt="c3RE Logo" style="height: 200px "/>
Your job $jobId is $myPositionInQueue in the queue.
</body>
</html>
EOT;
    exit;
}



$err='';
switch($_GET['err']){
    case 'notags':
        $err='Please provide at least one tag';
        break;
}
?>
<html>
<head>
    <title>c3RE AuerBoxTag Generator</title>
</head>
<body>
<img src="/logo.png" alt="c3RE Logo" style="height: 200px "/>
<h1>c3RE AuerBoxTag Generator</h1>
    <div style="color:red"><?php echo $err; ?></div>
<form method="post" action="/">

    <textarea name="tags" rows="10" cols="30" placeholder="one tag per line please"></textarea>
    <br>
    <br>
    <input type="submit" value="Lets Go!">
</form>
</body>
</html>
